Subject: Re: bug#43889: 28.0.50; [PATCH] Add new smiley-style emoji to Gnus

From: Robert Pluim <[email-masked]>
Date: Mon, 12 Oct 2020 11:03:53 +0200

(*sigh*, either gmane or bug-gnu-emacs or Gnus mangled the Reply-To
header here)

>>>>> On Sat, 10 Oct 2020 13:55:54 +0200, Unknown <[email-masked]> said:

    Adam> Eli writes:
    >>>> It doesn't actually test for HarfBuzz availability, or did I miss
    >>>> that?
    >>> 
    >>> It doesn't - you have to choose the style yourself, by customizing the
    >>> smiley-style variable.
    >> 
    >> How about adding that: the font-backend frame parameter should tell
    >> you if HarfBuzz is available.

By looking for the substring 'hb' in it? Could we add something a
little less icky, along the lines of 'libxml-available-p'?

    Adam> Do you mean removing the option if HarfBuzz isn't available?

I donʼt think this is dependent on Harfbuzz, etc/NEWS.27:

    ** Multicolor fonts such as "Noto Color Emoji" can be displayed on
    Emacs configured with Cairo drawing and linked with cairo >= 1.16.0.

(and on macOS, if explicitly requested)

    Adam> As far as I understand it, emoji can be displayed without, they just
    Adam> won't have color? Which might be something that users without HarfBuzz
    Adam> would like to be able to choose.

    Adam> (Having color emoji is just my motivation to make the patch.)

They'd be displayed with whatever font Emacs found for them.

    >> Perhaps when HarfBuzz is being used, it should be the default?  I
    >> don't use Gnus, but maybe such a new default will make sense to Gnus
    >> users?

    Adam> I think changing the default would be annoying to users, but I don't
    Adam> have any evidence in either direction. Maybe some users would consider
    Adam> it "modern" to change it.

As a Gnus user I wouldnʼt object to it being the default, as long as
there was a reasonable fallback for when those characters cannot be
displayed.

Robert
--